package org.jeecg.modules.travelSpot.entity;

import java.io.Serializable;
import java.io.UnsupportedEncodingException;
import java.util.Date;
import java.math.BigDecimal;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.jeecg.common.aspect.annotation.Dict;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * @Description: 地点表
 * @Author: jeecg-boot
 * @Date:   2024-09-25
 * @Version: V1.0
 */
@Data
@TableName("travel_spot")
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="travel_spot对象", description="地点表")
public class TravelSpot implements Serializable {
    private static final long serialVersionUID = 1L;

	/**主键*/
	@TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty(value = "主键")
    private java.lang.String id;
	/**地点名字*/
	@Excel(name = "地点名字", width = 15)
    @ApiModelProperty(value = "地点名字")
    private java.lang.String spotName;
	/**地点图片*/
	@Excel(name = "地点图片", width = 15)
    @ApiModelProperty(value = "地点图片")
    private java.lang.String spotImage;
	/**地点坐标_经度*/
	@Excel(name = "地点坐标_经度", width = 15)
    @ApiModelProperty(value = "地点坐标_经度")
    private java.math.BigDecimal spotLongitude;
	/**地点坐标_纬度*/
	@Excel(name = "地点坐标_纬度", width = 15)
    @ApiModelProperty(value = "地点坐标_纬度")
    private java.math.BigDecimal spotLatitude;
	/**地点所属景区(0-瓷都镇区 1-湖田片区 2-高岭片区 3-瑶里片区 4-蛟潭片区)*/
	@Excel(name = "地点所属景区(0-瓷都镇区 1-湖田片区 2-高岭片区 3-瑶里片区 4-蛟潭片区)", width = 15, dictTable = "travel_area", dicText = "area_name", dicCode = "id")
	@Dict(dictTable = "travel_area", dicText = "area_name", dicCode = "id")
    @ApiModelProperty(value = "地点所属景区(0-瓷都镇区 1-湖田片区 2-高岭片区 3-瑶里片区 4-蛟潭片区)")
    private java.lang.String areaId;
	/**地点类型(0-景点 1-美食店铺 2-民宿 3-厕所)*/
	@Excel(name = "地点类型(0-景点 1-美食店铺 2-民宿 3-厕所)", width = 15)
    @ApiModelProperty(value = "地点类型(0-景点 1-美食店铺 2-民宿 3-厕所)")
    private java.lang.Integer categoryId;
	/**地点详情*/
	@Excel(name = "地点详情", width = 15)
    @ApiModelProperty(value = "地点详情")
    private java.lang.String spotDetail;
	/**语音讲解内容*/
	@Excel(name = "语音讲解内容", width = 15)
    @ApiModelProperty(value = "语音讲解内容")
    private java.lang.String spotAudio;
}
