package org.jeecg.modules.travelWaresOrder.entity;

import java.io.Serializable;
import java.io.UnsupportedEncodingException;
import java.util.Date;
import java.math.BigDecimal;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.jeecg.common.aspect.annotation.Dict;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * @Description: 商品订单表
 * @Author: jeecg-boot
 * @Date:   2024-10-07
 * @Version: V1.0
 */
@Data
@TableName("travel_wares_order")
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="travel_wares_order对象", description="商品订单表")
public class TravelWaresOrder implements Serializable {
    private static final long serialVersionUID = 1L;

	/**主键*/
	@TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty(value = "主键")
    private java.lang.String id;
	/**创建人*/
    @ApiModelProperty(value = "创建人")
    private java.lang.String createBy;
	/**创建日期*/
    @ApiModelProperty(value = "创建日期")
    private java.util.Date createTime;
	/**更新人*/
    @ApiModelProperty(value = "更新人")
    private java.lang.String updateBy;
	/**更新日期*/
    @ApiModelProperty(value = "更新日期")
    private java.util.Date updateTime;
	/**关联商品id*/
	@Excel(name = "关联商品id", width = 15, dictTable = "travel_wares", dicText = "wares_title", dicCode = "id")
	@Dict(dictTable = "travel_wares", dicText = "wares_title", dicCode = "id")
    @ApiModelProperty(value = "关联商品id")
    private java.lang.String waresId;
	/**关联收件人地址id*/
	@Excel(name = "关联收件人地址id", width = 15, dictTable = "travel_address", dicText = "address", dicCode = "id")
	@Dict(dictTable = "travel_address", dicText = "address", dicCode = "id")
    @ApiModelProperty(value = "关联收件人地址id")
    private java.lang.String addressId;
	/**下单须知*/
	@Excel(name = "下单须知", width = 15)
    @ApiModelProperty(value = "下单须知")
    private java.lang.String statement;
	/**产品数量*/
	@Excel(name = "产品数量", width = 15)
    @ApiModelProperty(value = "产品数量")
    private java.lang.Integer number;
	/**产品总价格*/
	@Excel(name = "产品总价格", width = 15)
    @ApiModelProperty(value = "产品总价格")
    private java.math.BigDecimal price;
	/**关联用户*/
	@Excel(name = "关联用户", width = 15, dictTable = "han_hai_member", dicText = "nick_name", dicCode = "id")
	@Dict(dictTable = "han_hai_member", dicText = "nick_name", dicCode = "id")
    @ApiModelProperty(value = "关联用户")
    private java.lang.String userId;
	/**订单状态(0-待支付 1-已支付 2-已完成)*/
	@Excel(name = "订单状态(0-待支付 1-已支付 2-已完成)", width = 15)
    @ApiModelProperty(value = "订单状态(0-待支付 1-已支付 2-已完成)")
    private java.lang.Integer status;
	/**收件人姓名*/
	@Excel(name = "收件人姓名", width = 15)
    @ApiModelProperty(value = "收件人姓名")
    private java.lang.String userName;
	/**收件人电话*/
	@Excel(name = "收件人电话", width = 15)
    @ApiModelProperty(value = "收件人电话")
    private java.lang.String userPhone;
	/**收件人地址*/
	@Excel(name = "收件人地址", width = 15)
    @ApiModelProperty(value = "收件人地址")
    private java.lang.String userAddress;
}
